"use strict";var _=require("crypto"),b=require("fs"),O=require("path"),q=require("url"),g=require("child_process");require("camelcase");var L=require("slash");require("@svgr/core"),require("dotenv/config");var d=require("@deploysentinel/debugger-core");require("lodash");function p(s){return s&&typeof s=="object"&&"default"in s?s:{default:s}}var T=p(_),c=p(b),u=p(O),$=p(L),w,v;process.env.DEPLOYSENTINEL_API_KEY,(w=process.env.API_URL)!=null,d.utils.stringToBoolean(process.env.DEPLOYSENTINEL_LOG_VERBOSE),d.utils.createRandomID(),d.utils.stringToBoolean((v=process.env.DEPLOYSENTINEL_REMOTE_DEBUGGING)!=null?v:"1"),d.utils.stringToBoolean(process.env.DEPLOYSENTINEL_UPLOAD_ON_PASSES);const a="./node_modules/.cache/@deploysentinel/jest-rtl-debugger",E="cache-sass-load-paths.config",x=()=>{c.default.existsSync(a)||c.default.mkdirSync(a,{recursive:!0})},P="\\.(css|less|sass|scss|styl|stylus|pcss|postcss)($|\\?)",j=new RegExp(`\\.module${P}`);function C(s){return/.(sass|scss)$/.test(s)}function N(s){return/.(less)$/.test(s)}function M(s){return C(s)||N(s)}function F(){const s=h(`const postcssrc = require('postcss-load-config');
  
  postcssrc().then(({ plugins, options }) => {
    console.log(true)
  })
  .catch(error=>{
    if (!/No PostCSS Config found/.test(error.message)) {
      throw new Error("Failed to load PostCSS config", error)
    }
    console.log(false)
  });`),e=g.spawnSync("node",[s]);c.default.unlink(s,o=>{if(o)throw o});const t=e.stderr.toString("utf-8").trim();if(t&&console.error(t),e.error)throw e.error;return e.stdout.toString().trim()==="true"}function k(s){return $.default(s.split(process.cwd())[1])}const f=s=>({code:`const style = document.createElement('style');
  style.appendChild(document.createTextNode(${JSON.stringify(s)}));
  document.head.appendChild(style);
  module.exports = {}`});function D(s,e){const t=k(e);console.time(`Processing ${t}`);let o=s;const r=j.test(e),i=M(e),n=c.default.existsSync(u.default.join(process.cwd(),"tailwind.config.js"))||c.default.existsSync(u.default.join(process.cwd(),"tailwind.config.cjs")),l=F();return!r&&!i&&!l&&!n?(console.timeEnd(`Processing ${t}`),f(o)):C(e)?f(R(e)):N(e)?f(A(e)):l||n||r?(console.timeEnd(`Processing ${t}`),I(o,e,{useConfigFile:l,isModule:r,haveTailwindCss:n})):(console.timeEnd(`Processing ${t}`),f(o))}function J(s){const e=s.trim().split("---"),t={cssModulesExportedTokens:"",css:""};for(const o of e){const[r,i]=o.trim().split("|||");r==="cssModulesExportedTokens"&&(t.cssModulesExportedTokens=i),r==="css"&&(t.css=i)}return t}function h(s){x();const e=u.default.join(a,T.default.randomBytes(16).toString("hex"));return c.default.writeFileSync(e,s),e}function I(s,e,t={useConfigFile:!0,isModule:!1,haveTailwindCss:!1}){var o;const r=`require('postcss-modules')({
    getJSON: (cssFileName, json, outputFileName) => {
      console.log('cssModulesExportedTokens|||', JSON.stringify(json));
      console.log('---')
    },
    // Use custom scoped name to prevent different hash between operating systems
    // Because new line characters can be different between operating systems. Reference: https://stackoverflow.com/a/10805198
    // Original hash function: https://github.com/madyankin/postcss-modules/blob/7d5965d4df201ef301421a5e35805d1b47f3c914/src/generateScopedName.js#L6
    generateScopedName: function (name, filename, css) {
      const stringHash = require('string-hash');
      const i = css.indexOf('.' + name);
      const line = css.substr(0, i).split(/[\\r\\n|\\n|\\r]/).length;
      // This is not how the real app work, might be an issue if we try to make the snapshot interactive
      // https://github.com/nvh95/jest-preview/issues/84#issuecomment-1146578932
      const removedNewLineCharactersCss = css.replace(/(\\r\\n|\\n|\\r)/g, '');
      const hash = stringHash(removedNewLineCharactersCss).toString(36).substr(0, 5);
      return '_' + name + '_' + hash + '_' + line;
    },
  })`;let i=`const postcss = require('postcss');
  const postcssrc = require('postcss-load-config');
  const isModule = ${t.isModule}
  const cssSrc = ${JSON.stringify(s)};
  
  // TODO: We have to re-execute "postcssrc()" every CSS file.
  // Can we do better? Singleton?
  postcssrc().then(({ plugins, options }) => {
    plugins.unshift(require('postcss-import')())
    if (isModule) {
      plugins.push(
        ${r},
      )
    }
    postcss(plugins)
      .process(cssSrc, { ...options, from: ${JSON.stringify(e)} })
      .then((result) => {
        console.log('css|||', result.css);
        console.log('---')
      });
  });`;t.useConfigFile||(i=`const postcss = require('postcss');
const isModule = ${t.isModule};
const haveTailwindCss = ${t.haveTailwindCss};
const cssSrc = ${JSON.stringify(s)};

let plugins = [];
if (isModule) {
  plugins.unshift(require('postcss-import')())
  plugins.push(
    ${r},
  )
}
if (haveTailwindCss) {
  // tailwindCss auto resolve config
  // https://github.com/tailwindlabs/tailwindcss/blob/cef02e2dc395ed5b5d31b72183cf7504b3bd76c1/src/util/resolveConfigPath.js#L45-L52
  plugins.push(require("tailwindcss")())
}
postcss(plugins)
.process(cssSrc, { from: ${JSON.stringify(e)} })
.then((result) => {
  console.log('css|||', result.css);
  console.log('---')
});`);const n=h(i),l=g.spawnSync("node",[n]);c.default.unlink(n,y=>{if(y)throw y});const m=(o=l.stderr)==null?void 0:o.toString("utf-8").trim();if(m&&console.error(m),l.error)throw l.error;const S=J(l.stdout.toString());return{code:`const style = document.createElement("style");
style.type = "text/css";
const styleContent = ${JSON.stringify(S.css)};
style.appendChild(document.createTextNode(styleContent.replace(/\\\\/g, '')));
document.head.appendChild(style);
module.exports = ${S.cssModulesExportedTokens||"{}"}`}}function R(s){let e;try{e=require("sass")}catch(n){throw console.log(n),new Error("Sass not found. Please install sass and try again.")}const t=u.default.join(a,E);let o;if(c.default.existsSync(t)){const n=c.default.readFileSync(u.default.join(a,E),"utf8").trim();o=JSON.parse(n)}else o=[];let r;const i=n=>n.startsWith("~")?new URL(u.default.join(q.pathToFileURL("node_modules").href,n.substring(1))):null;if(e.compile)r=e.compile(s,{loadPaths:o,importers:[{findFileUrl(n){return i(n)}}]}).css;else if(e.renderSync)r=e.renderSync({file:s,includePaths:o,importer:[function(n){return i(n)}]}).css.toString();else throw new Error("Cannot compile sass to css: No compile method is available.");return r}function A(s){console.log("processLess",s);try{require("less")}catch(i){throw console.log(i),new Error("Less not found. Please install less and try again.")}const e=`const less = require('less');
  const fs = require('fs');
  const path = require('path');
  const cssContent = fs.readFileSync(${JSON.stringify(s)}, 'utf8');
  less.render(cssContent, { filename: ${JSON.stringify(s)}}).then((output) => {
    console.log(output.css);
  });`,t=h(e),o=g.spawnSync("node",[t]);c.default.unlink(t,i=>{if(i)throw i});const r=o.stderr.toString("utf-8").trim();if(r&&console.error(r),o.error)throw o.error;return o.stdout.toString()}function B(s,e){return D(s,e)}var U={process:B};module.exports=U;
